import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.LinkedList;


public class Grasshop {

	private static int [][] pole;
	private static int x0, y0;
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String str;
		String[] radek;
		LinkedList<Boda> list = new LinkedList<Boda>();
		int gx,gy,lx,ly;
		
		while((str = br.readLine()) != null){
			radek = str.split(" ");
			x0 = Integer.parseInt(radek[0]);
			y0 = Integer.parseInt(radek[1]);
			gx = Integer.parseInt(radek[2]);
			gy = Integer.parseInt(radek[3]);
			lx = Integer.parseInt(radek[4]);
			ly = Integer.parseInt(radek[5]);
			
			pole = new int [x0][y0];
			
			Boda b = new Boda(gx-1, gy-1, 1);
			list.clear();
			list.addLast(b);

			int vzdal = -1;
			do
			{
				Boda a = list.getFirst();
				list.removeFirst();
				int x = a.x;
				int y = a.y;

				if (x == lx-1 && y == ly-1)
				{
					vzdal = a.v-1;
					break;
				}
				
				if (isValid(x+1, y+2))
				{
					list.addLast(new Boda(x+1, y+2, a.v+1));
					pole[x+1][y+2] = a.v+1;
				}
				if (isValid(x+1, y-2))
				{
					list.addLast(new Boda(x+1, y-2, a.v+1));
					pole[x+1][y-2] = a.v+1;
				}
				if (isValid(x-1, y+2))
				{
					list.addLast(new Boda(x-1, y+2, a.v+1));
					pole[x-1][y+2] = a.v+1;
				}
				if (isValid(x-1, y-2))
				{
					list.addLast(new Boda(x-1, y-2, a.v+1));
					pole[x-1][y-2] = a.v+1;
				}
				if (isValid(x+2, y+1))
				{
					list.addLast(new Boda(x+2, y+1, a.v+1));
					pole[x+2][y+1] = a.v+1;
				}
				if (isValid(x+2, y-1))
				{
					list.addLast(new Boda(x+2, y-1, a.v+1));
					pole[x+2][y-1] = a.v+1;
				}
				if (isValid(x-2, y+1))
				{
					list.addLast(new Boda(x-2, y+1, a.v+1));
					pole[x-2][y+1] = a.v+1;
				}
				if (isValid(x-2, y-1))
				{
					list.addLast(new Boda(x-2, y-1, a.v+1));
					pole[x-2][y-1] = a.v+1;
				}
					
			} while(!list.isEmpty());
			
			
			
			System.out.println(vzdal == -1 ? "impossible" : vzdal);
		}
		
	}
	
	private static boolean isValid(int x, int y)
	{
		return	x >= 0 &&
				x < x0 &&
				y >= 0 &&
				y < y0 &&
				pole[x][y] == 0;
	}

}


class Boda
{
	public int x;
	public int y;
	public int v;
	
	public Boda(int x, int y, int v)
	{
		this.x = x;
		this.y = y;
		this.v = v;
	}
}